//--------------------------------------------------------------------
#ifndef _DONUT_H_
#define _DONUT_H_

#include <basic.h>
#include <pt3.h>
#include <pt2.h>
#include <vector.h>

//--------------------------------------------------------------------
class Donut
{
	public:
		Donut();
		~Donut();

		Int GetNumSteps() const {return steps_;}
		void SetNumSteps(Int s);

		Pt3 GetCenter() const {return center_;}
		void SetCenter(const Pt3 &c);

		Pt3 GetMajorAxis() const {return major_axis_;}
		void SetMajorAxis(const Pt3 &c);

		Pt3 GetMinorAxis() const {return minor_axis_;}
		void SetMinorAxis(const Pt3 &c);

		vector<Pt3> &GetSpine() {return spine_;}
		vector<Pt3> &GetSpineTan() {return tans_;}
		vector<Pt3> &GetRights() {return rights_;}
		vector<Pt3> &GetUps() {return ups_;}

		void CalcSpine();
		void DrawSpine();

		Float GetThickness() const {return thickness_;}
		void SetThickness(Float);

		vector<vector<Pt3> > &GetRings() {return rings_;}
		vector<vector<Pt3> > &GetNormals() {return normals_;}
		vector<vector<Pt2> > &GetTexCoords() {return texCoords_;}

		void CalcRings();
		void DrawRings();

		void DrawSurface();
		void Draw();
		void Material();

		const Pt3 &GetColor() const {return color_;}
		void SetColor(const Pt3 &);

	private:
		Int steps_;

		Pt3 center_;
		Pt3 major_axis_;
		Pt3 minor_axis_;

		Float thickness_;

		vector<Pt3> spine_;
		vector<Pt3> tans_;
		vector<Pt3> rights_;
		vector<Pt3> ups_;

		vector<vector<Pt3> > rings_;
		vector<vector<Pt3> > normals_;
		vector<vector<Pt2> > texCoords_;

		Pt3 color_;
};

//--------------------------------------------------------------------
#endif // _DONUT_H_
