// OpenGLView.h : interface of the COpenGLView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_OPENGLVIEW_H__26195EBC_F999_11D1_AC33_000000000000__INCLUDED_)
#define AFX_OPENGLVIEW_H__26195EBC_F999_11D1_AC33_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <gl\gl.h>
#include <gl\glu.h>
#include <pt3.h>
class Pt2;
class World;

class COpenGLView : public CView
{
protected: // create from serialization only
	COpenGLView();
	DECLARE_DYNCREATE(COpenGLView)

// Attributes
public:
	COpenGLDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COpenGLView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~COpenGLView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(COpenGLView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
   afx_msg void OnMButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRenderFill();
	afx_msg void OnRenderLine();
	afx_msg void OnRenderPoint();
	afx_msg void OnUpdateRenderFill(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRenderLine(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRenderPoint(CCmdUI* pCmdUI);
	afx_msg void OnRenderShadingFlat();
	afx_msg void OnUpdateRenderShadingFlat(CCmdUI* pCmdUI);
	afx_msg void OnRenderShadingSmooth();
	afx_msg void OnUpdateRenderShadingSmooth(CCmdUI* pCmdUI);
    afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnUpdateRotate(CCmdUI* pCmdUI);
	afx_msg void OnRotate();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	int GetWidth() const {return width_;}
	void SetWidth(int w);
	int GetHeight() const {return height_;}
	void SetHeight(int h);
	double GetZoom() const {return zoom_;}
	void SetZoom(double z);
	double GetLeft() const {return left_;}
	void SetLeft(double);
	double GetRight() const {return right_;}
	void SetRight(double);
	double GetTop() const {return top_;}
	void SetTop(double);
	double GetBottom() const {return bottom_;}
	void SetBottom(double);
	double GetNear() const {return near_;}
	void SetNear(double);
	double GetFar() const {return far_;}
	void SetFar(double);
	double GetXAng() const {return xang_;}
	void SetXAng(double);
	double GetYAng() const {return yang_;}
	void SetYAng(double);
	int GetMX() const {return mx_;}
	void SetMX(int);
	int GetMY() const {return my_;}
	void SetMY(int);

	World *GetWorld() {return w_;}

	void PanView(const Pt2 &p);

	Pt3 &GetEye() {return eye_;}
	void SetEye(const Pt3 &);
	Pt3 &GetFocus() {return focus_;}
	void SetFocus(const Pt3 &);
	Pt3 &GetUp() {return up_;}
	void SetUp(const Pt3 &);

   void GenericButtonDown(UINT nFlags, CPoint point);
   void GenericButtonUp(UINT nFlags, CPoint point);

private:
	int		m_PixelFormat;
	HGLRC	m_hRC;
	CDC*	m_pDC;
	int width_;
	int height_;
	double left_;
	double right_;
	double top_;
	double bottom_;
	double near_;
	double far_;
	double zoom_;
	double xang_;
	double yang_;
	Pt3 eye_;
	Pt3 focus_;
	Pt3 up_;
	int mx_;
	int my_;
	World *w_;
};

#ifndef _DEBUG  // debug version in OpenGLView.cpp
inline COpenGLDoc* COpenGLView::GetDocument()
   { return (COpenGLDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPENGLVIEW_H__26195EBC_F999_11D1_AC33_000000000000__INCLUDED_)
