//--------------------------------------------------------------------
#ifndef _SPHERE_H_
#define _SPHERE_H_

#include <basic.h>
#include <Pt3.h>
#include <vector.h>

//--------------------------------------------------------------------
class Sphere
{
	public:
		Sphere();
		~Sphere();

		void Draw();
		void calc();

		Int getNumXSteps() const {return m_xSteps;}
		void setNumXSteps(Int s);

		Int getNumYSteps() const {return m_ySteps;}
		void setNumYSteps(Int s);

		Pt3 getCenter() const {return m_center;}
		void setCenter(const Pt3 &c);

		Pt3 getMajorAxis() const {return m_majorAxis;}
		void setMajorAxis(const Pt3 &c);

		Pt3 getTop() const {return m_top;}
		void setTop(const Pt3 &a);

		Pt3 getBottom() const {return m_bottom;}
		void setBottom(const Pt3 &a);

		vector<vector<Pt3> > &getRings() {return m_rings;}
		vector<vector<Pt3> > &getNormals() {return m_normals;}
		// vector<vector<Pt3> > &getColors() {return m_colors;}

		void drawRings();

		void drawSurface();

		void material();

	private:
		Int m_xSteps;
		Int m_ySteps;

		Pt3 m_center;
		Pt3 m_majorAxis;
		Pt3 m_top;
		Pt3 m_bottom;

		vector<vector<Pt3> > m_rings;
		vector<vector<Pt3> > m_normals;
		vector<vector<Pt3> > m_colors;		
};

//--------------------------------------------------------------------

#endif // _SPHERE_H_
