//--------------------------------------------------------------------
#ifndef _WORLD_H_
#define _WORLD_H_

#include <basic.h>
#include <pt3.h>
#include <vector.h>

#include <gl\gl.h>

class Borromean;

//--------------------------------------------------------------------

class World
{
	public:
		World();
		~World();
		void Draw();
		Borromean *GetBorromean() {return borr_;}
		vector<Pt3> &GetLights() {return lights_;}
		void InitLight();
		GLenum GetPolygonMode() const {return pgonmode_;}
		void SetPolygonMode(GLenum);
		GLenum GetShadeModel() const {return shademodel_;}
		void SetShadeModel(GLenum);
	private:
		Borromean *borr_;
		vector<Pt3> lights_;
		GLenum pgonmode_;
		GLenum shademodel_;
};

//--------------------------------------------------------------------
#endif _WORLD_H_
