//--------------------------------------------------------------------
#include <borromean.h>
#include <donut.h>
#include <gl\gl.h>

//--------------------------------------------------------------------
Borromean::Borromean()
{
	for(Int i=0; i<3; ++i) {
		d_[i] = new Donut();
		d_[i]->CalcSpine();
		d_[i]->CalcRings();
	}

	d_[0]->SetMajorAxis(Pt3(1.0, 0.0, 0.0));
	d_[0]->SetMinorAxis(Pt3(0.0, 0.5, 0.0));
	d_[0]->SetColor(Pt3(0.0, 1.0, 0.0));

	d_[1]->SetMajorAxis(Pt3(0.0, 1.0, 0.0));
	d_[1]->SetMinorAxis(Pt3(0.0, 0.0, 0.5));
	d_[1]->SetColor(Pt3(0.0, 0.0, 1.0));

	d_[2]->SetMajorAxis(Pt3(0.0, 0.0, 1.0));
	d_[2]->SetMinorAxis(Pt3(0.5, 0.0, 0.0));
	d_[2]->SetColor(Pt3(1.0, 0.0, 0.0));

	for(i=0; i<3; ++i) {
		d_[i]->CalcSpine();
		d_[i]->CalcRings();
	}
}

//--------------------------------------------------------------------
Borromean::~Borromean()
{
	for(Int i=0; i<3; ++i) {
		delete d_[i];
	}
}

//--------------------------------------------------------------------
void Borromean::Draw()
{
	for(Int i=0; i<3; ++i) {
		Donut *d = GetDonut(i);
		if(d) {
			d->Draw();
		}
	}
}

//--------------------------------------------------------------------
